package cokr.xit.fims.payer.dao;

import java.util.List;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.fims.payer.Payer;
import cokr.xit.fims.payer.PayerQuery;

/** 납부자 주소 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2024-05-23	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("payerAddrMapper")
public interface PayerAddrMapper extends AbstractMapper {

	/**지정한 조건에 따라 납부자 주소 목록을 조회하여 반환한다.<br />
	 * @param req 납부자 주소 조회 조건
	 * @return 납부자 주소 목록
	 */
	List<DataObject> selectAddrList(PayerQuery req);

	/**지정한 조건에 따라 납부자 주소 객체들을 반환한다.
	 * @param req 납부자 주소 조회 조건
	 * @return 납부자 주소 객체 목록
	 */
	List<Payer> selectAddrs(PayerQuery req);

	/**지정한 조건에 따라 납부자 주소 정보를 반환한다.
	 * @param req 부과제외 조회 조건
	 * @return 납부자 주소 정보
	 */
	List<Payer> selectPayerAddrInfo(PayerQuery req);

	/**납부자 주소 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"payerAddr" - 납부자 주소</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertPayerAddr(Payer payer);

	/**납부자 주소 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"payerAddr" - 납부자 주소</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updatePayerAddr(Payer payer);

	/**지정한 조건에 따라 납부자 주소 변경 이력 객체들을 반환한다.
	 * @param req 납부자 대장 조회 조건
	 * @return 납부자 대장 객체 목록
	 */
	List<DataObject> selectPayerAddrHstrys(PayerQuery req);



    /**지정한 조건에 따라 납부자 주소 정보를 반환한다.
     * @param req 부과제외 조회 조건
     * @return 납부자 주소 정보
     */
    List<DataObject> selectLastPayerAddrs(PayerQuery req);

    /**지정한 조건에 따라 부과제외 대장 정보를 조회하여 반환한다.
     * @param req 부과제외 대장 조회 조건
     * @return 부과제외 대장 정보
     */
    default DataObject selectLastPayerAddrInfo(PayerQuery req) {
        // 기본 정렬
        if (req.getOrderBy() == null) {
            req.setOrderBy("P.RTPYR_ID DESC, PA.ADDR_SN DESC");
        }

        List<DataObject> payers = selectLastPayerAddrs(req);

        return !payers.isEmpty() ? payers.get(0) : null;
    }

}
